<template>
  <div
    ref="collection_wrapper"
    :style="{maxHeight: max_height}"
    class="app-collection cards d-flex flex-column"
  >
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="ac__header">
      <!-- @slot Use this slot for header -->
      <slot name="header"></slot>
    </header>

    <main class="ac__body">
      <!-- @slot Use this slot for body -->
      <slot name="body" :data="data"></slot>

      <div
        v-show="load_more_type === 'loadMoreButton'"
        ref="loader_div"
        class="load-more text-center"
      >
        <!--
          @slot Slot for load more button, shown only if load_more_type is 'loadMoreButton'
          and there is more data to fetch
        -->
        <slot name="load_more_button"></slot>
      </div>
    </main>

    <footer class="ac__footer">
      <!-- @slot Use this slot for footer -->
      <slot name="footer"></slot>
    </footer>
  </div>
</template>

<script>
import AppData from './mixins/ac-data'

/**
 * ac Colection component which can be used to display data from API
 * @requires VueBootstrap
 * @requires ac-data.js
 */
export default {
  name: 'ac-collection',

  mixins: [AppData],

  props: {
    /**
     * @param {string} loading_image - Image to show while loading data
     */
    loading_image: {
      type: String,
      required: true,
    },

    /**
     * @param {string} max_height - Max height of component
     */
    max_height: {
      type: String,
      required: false,
      default: '100%',
    },

    /**
     * @param {string} load_more_type - Type of loading more information
     * @default loadMoreButton
     * 'loadMoreButton, infiniScroll'
     */
    load_more_type: {
      type: String,
      default: 'loadMoreButton',
      validator: value => ['loadMoreButton', 'infiniScroll'].indexOf(value) !== -1,
    },
  },

  created() {
    this.$parent.$emit('collection_added', { name: this.$options.name, component: this })
  },

  mounted() {
    /**
    * If prop load_more_type is infiniScroll then add listener for scroll
    * when scroll reaches bottom of page then load more data
    */
    if (this.load_more_type === 'infiniScroll') {
      const wrapper = this.$refs.collection_wrapper
      wrapper.onscroll = () => {
        if (wrapper.scrollTop === (wrapper.scrollHeight - wrapper.offsetHeight)) {
          if (!this.is_loading) {
            this.has_more()
            this.set_ajax()
          }
        }
      }
    }
  },

  beforeDestroy() {
    /**
    * Remove scroll listener when component about to destroy
    */
    window.onscroll = () => {}

    this.$parent.$emit('collection_removed', { name: this.$options.name, component: this })
  },
}
</script>

<style scoped>
  .ac__item {
    display: flex;
    flex-wrap: wrap;
  }

  .app-collection {
    overflow-y: auto;
    overflow-x: hidden;
  }

  .ac__body {
    flex: auto;
  }

  .loader {
    position: fixed;
    display: flex;
    align-items: center;
    justify-content: center;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 999;
    background-color: rgba(255, 255, 255, .65);
  }
</style>
